Index: trunk/src/VBox/ValidationKit/testmanager/webui/wuiadminschedgroup.py
===================================================================
--- trunk/src/VBox/ValidationKit/testmanager/webui/wuiadminschedgroup.py	(revision 83366)
+++ trunk/src/VBox/ValidationKit/testmanager/webui/wuiadminschedgroup.py	(revision 83385)
@@ -86,9 +86,9 @@
         oForm.addListOfSchedGroupMembers(SchedGroupDataEx.ksParam_aoMembers,
                                          oData.aoMembers, self._aoAllRelevantTestGroups,    'Test groups',
-                                         fReadOnly = self._sMode == WuiFormContentBase.ksMode_Show);
+                                         oData.idSchedGroup, fReadOnly = self._sMode == WuiFormContentBase.ksMode_Show);
 
         oForm.addListOfSchedGroupBoxes(SchedGroupDataEx.ksParam_aoTestBoxes,
                                        oData.aoTestBoxes, self._aoAllRelevantTestBoxes,     'Test boxes',
-                                       fReadOnly = self._sMode == WuiFormContentBase.ksMode_Show);
+                                       oData.idSchedGroup, fReadOnly = self._sMode == WuiFormContentBase.ksMode_Show);
 
         oForm.addMultilineText(SchedGroupData.ksParam_sComment,     oData.sComment,         'Comment');
Index: trunk/src/VBox/ValidationKit/testmanager/webui/wuiadmintestbox.py
===================================================================
--- trunk/src/VBox/ValidationKit/testmanager/webui/wuiadmintestbox.py	(revision 83366)
+++ trunk/src/VBox/ValidationKit/testmanager/webui/wuiadmintestbox.py	(revision 83385)
@@ -111,5 +111,5 @@
                                              oData.aoInSchedGroups,
                                              SchedGroupLogic(TMDatabaseConnection()).fetchOrderedByName(),
-                                             'Scheduling Group');
+                                             'Scheduling Group', oData.idTestBox);
         # Command, comment and submit button.
         if self._sMode == WuiFormContentBase.ksMode_Edit:
Index: trunk/src/VBox/ValidationKit/testmanager/webui/wuihlpform.py
===================================================================
--- trunk/src/VBox/ValidationKit/testmanager/webui/wuihlpform.py	(revision 83366)
+++ trunk/src/VBox/ValidationKit/testmanager/webui/wuihlpform.py	(revision 83385)
@@ -765,5 +765,5 @@
 
     def addListOfSchedGroupMembers(self, sName, aoSchedGroupMembers, aoAllRelevantTestGroups,  # pylint: disable=too-many-locals
-                                   sLabel, fReadOnly = True):
+                                   sLabel, idSchedGroup, fReadOnly = True):
         """
         For WuiAdminSchedGroup.
@@ -821,5 +821,5 @@
                       % ( 'tmodd' if iTestGroup & 1 else 'tmeven',
                           sPrefix, SchedGroupMemberData.ksParam_idTestGroup,    oTestGroup.idTestGroup,
-                          sPrefix, SchedGroupMemberData.ksParam_idSchedGroup,   -1 if oMember is None else oMember.idSchedGroup,
+                          sPrefix, SchedGroupMemberData.ksParam_idSchedGroup,   idSchedGroup,
                           sPrefix, SchedGroupMemberData.ksParam_tsExpire,       '' if oMember is None else oMember.tsExpire,
                           sPrefix, SchedGroupMemberData.ksParam_tsEffective,    '' if oMember is None else oMember.tsEffective,
@@ -863,6 +863,6 @@
                          u'</table>\n');
 
-    def addListOfSchedGroupBoxes(self, sName, aoSchedGroupBoxes, aoAllRelevantTestBoxes,  # pylint: disable=too-many-locals
-                                 sLabel, fReadOnly = True): # (str, list[TestBoxDataEx], list[TestBoxDataEx], str, bool) -> str
+    def addListOfSchedGroupBoxes(self, sName, aoSchedGroupBoxes, aoAllRelevantTestBoxes, sLabel, # pylint: disable=too-many-locals
+                                 idSchedGroup, fReadOnly = True): # (str, list[TestBoxDataEx], list[TestBoxDataEx], str, bool) -> str
         """
         For WuiAdminSchedGroup.
@@ -918,5 +918,5 @@
                       % ( 'tmodd' if iTestBox & 1 else 'tmeven',
                           sPrefix, TestBoxDataForSchedGroup.ksParam_idTestBox,    oTestBox.idTestBox,
-                          sPrefix, TestBoxDataForSchedGroup.ksParam_idSchedGroup, -1 if oMember is None else oMember.idSchedGroup,
+                          sPrefix, TestBoxDataForSchedGroup.ksParam_idSchedGroup, idSchedGroup,
                           sPrefix, TestBoxDataForSchedGroup.ksParam_tsExpire,     '' if oMember is None else oMember.tsExpire,
                           sPrefix, TestBoxDataForSchedGroup.ksParam_tsEffective,  '' if oMember is None else oMember.tsEffective,
@@ -940,5 +940,5 @@
 
     def addListOfSchedGroupsForTestBox(self, sName, aoInSchedGroups, aoAllSchedGroups, sLabel,  # pylint: disable=too-many-locals
-                                       fReadOnly = None):
+                                       idTestBox, fReadOnly = None):
         # type: (str, TestBoxInSchedGroupDataEx, SchedGroupData, str, bool) -> str
         """
@@ -1004,6 +1004,6 @@
                       u'    </td>\n'
                       % ( 'tmodd' if iSchedGroup & 1 else 'tmeven',
-                          sPrefix, TestBoxInSchedGroupData.ksParam_idSchedGroup,  oSchedGroup.idSchedGroup,
-                          sPrefix, TestBoxInSchedGroupData.ksParam_idTestBox,   -1 if oMember is None else oMember.idTestBox,
+                          sPrefix, TestBoxInSchedGroupData.ksParam_idSchedGroup, oSchedGroup.idSchedGroup,
+                          sPrefix, TestBoxInSchedGroupData.ksParam_idTestBox,   idTestBox,
                           sPrefix, TestBoxInSchedGroupData.ksParam_tsExpire,    '' if oMember is None else oMember.tsExpire,
                           sPrefix, TestBoxInSchedGroupData.ksParam_tsEffective, '' if oMember is None else oMember.tsEffective,