Index: trunk/src/VBox/ValidationKit/testmanager/core/db.py
===================================================================
--- trunk/src/VBox/ValidationKit/testmanager/core/db.py	(revision 83395)
+++ trunk/src/VBox/ValidationKit/testmanager/core/db.py	(revision 83396)
@@ -642,8 +642,8 @@
             iEntry += 1;
             sDebug += ' <tr>\n' \
-                      '  <td align="right">%s</td>\n' \
-                      '  <td align="right">%s</td>\n' \
-                      '  <td align="right">%s</td>\n' \
-                      '  <td align="right">%s</td>\n' \
+                      '  <td>%s</td>\n' \
+                      '  <td>%s</td>\n' \
+                      '  <td>%s</td>\n' \
+                      '  <td>%s</td>\n' \
                       '  <td><pre>%s</pre></td>\n' \
                       '  <td>%s</td>\n' \
Index: trunk/src/VBox/ValidationKit/testmanager/htdocs/css/common.css
===================================================================
--- trunk/src/VBox/ValidationKit/testmanager/htdocs/css/common.css	(revision 83395)
+++ trunk/src/VBox/ValidationKit/testmanager/htdocs/css/common.css	(revision 83396)
@@ -739,4 +739,9 @@
 }
 
+table.tmformtblschedgroupmembers tr td:nth-child(3),
+table.tmformtblschedgroupmembers tr td:nth-child(4) {
+    text-align: center;
+}
+
 
 /*
@@ -821,4 +826,12 @@
 table.tmlistnavtab {
     width:          100%;
+}
+
+table.tmlistnavtab tr td:nth-child(1) {
+    text-align:     left;
+}
+
+table.tmlistnavtab tr td:nth-child(2) {
+    text-align:     right;
 }
 
@@ -1073,4 +1086,16 @@
 }
 
+table.tmsqltable tr td {
+    text-align:     left;
+}
+
+table.tmsqltable tr td:nth-child(1),
+table.tmsqltable tr td:nth-child(2),
+table.tmsqltable tr td:nth-child(3),
+table.tmsqltable tr td:nth-child(4) {
+    text-align:     right;
+}
+
+
 
 /*
Index: trunk/src/VBox/ValidationKit/testmanager/webui/wuicontentbase.py
===================================================================
--- trunk/src/VBox/ValidationKit/testmanager/webui/wuicontentbase.py	(revision 83395)
+++ trunk/src/VBox/ValidationKit/testmanager/webui/wuicontentbase.py	(revision 83396)
@@ -524,10 +524,14 @@
             if isinstance(oChange, AttributeChangeEntryPre):
                 sContent += '        <tr class="%s%s"><td>%s</td>'\
-                            '<td><div class="tdpre"><pre>%s</pre></div></td>' \
-                            '<td><div class="tdpre"><pre>%s</pre></div></td></tr>\n' \
+                            '<td><div class="tdpre">%s%s%s</div></td>' \
+                            '<td><div class="tdpre">%s%s%s</div></td></tr>\n' \
                           % ( sRowClass, 'odd' if j & 1 else 'even',
                               webutils.escapeElem(oChange.sAttr),
-                              webutils.escapeElem(oChange.sOldText),
-                              webutils.escapeElem(oChange.sNewText), );
+                              '<pre>' if oChange.sOldText else '',
+                               webutils.escapeElem(oChange.sOldText),
+                              '</pre>' if oChange.sOldText else '',
+                              '<pre>' if oChange.sNewText else '',
+                              webutils.escapeElem(oChange.sNewText),
+                              '</pre>' if oChange.sNewText else '', );
             else:
                 sContent += '        <tr class="%s%s"><td>%s</td><td>%s</td><td>%s</td></tr>\n' \
@@ -555,5 +559,5 @@
 
         # Prev and combo box in one cell. Both inside the form for formatting reasons.
-        sNavigation += '    <td align="left">\n' \
+        sNavigation += '    <td>\n' \
                        '    <form name="ChangeLogEntriesPerPageForm" method="GET">\n'
 
@@ -592,8 +596,8 @@
         if fMoreEntries:
             dParams[WuiDispatcherBase.ksParamChangeLogPageNo] = iPageNo + 1;
-            sNavigation += '    <td align="right"><a href="?%s#tmchangelog">Next</a></td>\n' \
+            sNavigation += '      <td><a href="?%s#tmchangelog">Next</a></td>\n' \
                          % (webutils.encodeUrlParams(dParams),);
         else:
-            sNavigation += '      <td align="right">Next</td>\n';
+            sNavigation += '      <td>Next</td>\n';
 
         sNavigation += '    </tr>\n' \
@@ -645,5 +649,5 @@
             sContent += self.formatChangeLogEntry(aoEntries, iEntry, sUrl, dParams);
 
-        sContent += '    <tbody>\n' \
+        sContent += '    </tbody>\n' \
                     '  </table>\n';
         if fShowNavigation and len(aoEntries) >= 8:
Index: trunk/src/VBox/ValidationKit/testmanager/webui/wuihlpform.py
===================================================================
--- trunk/src/VBox/ValidationKit/testmanager/webui/wuihlpform.py	(revision 83395)
+++ trunk/src/VBox/ValidationKit/testmanager/webui/wuihlpform.py	(revision 83396)
@@ -780,5 +780,5 @@
                       ','.join([unicode(oTestGroup.idTestGroup) for oTestGroup in aoAllRelevantTestGroups]), ));
 
-        self._add(u'<table class="tmformtbl">\n'
+        self._add(u'<table class="tmformtbl tmformtblschedgroupmembers">\n'
                   u' <thead>\n'
                   u'  <tr>\n'
@@ -828,7 +828,7 @@
                           oTestGroup.idTestGroup, oTestGroup.idTestGroup, escapeElem(oTestGroup.sName),
                           ));
-            self._add(u'    <td align="left">%s</td>\n' % ( escapeElem(oTestGroup.sName), ));
-
-            self._add(u'    <td align="center">\n'
+            self._add(u'    <td>%s</td>\n' % ( escapeElem(oTestGroup.sName), ));
+
+            self._add(u'    <td>\n'
                       u'      <input name="%s[%s]" type="text" value="%s" style="max-width:3em;" %s>\n'
                       u'    </td>\n'
@@ -837,5 +837,5 @@
                           ' readonly class="tmform-input-readonly"' if fReadOnly else '', ));
 
-            self._add(u'    <td align="center">\n'
+            self._add(u'    <td>\n'
                       u'      <select name="%s[%s]" id="%s[%s]" class="tmform-combobox"%s>\n'
                       u'        <option value="-1"%s>None</option>\n'
@@ -853,5 +853,5 @@
                       u'    </td>\n');
 
-            self._add(u'    <td align="left">\n'
+            self._add(u'    <td>\n'
                       u'      Todo<input name="%s[%s]" type="hidden" value="%s">\n'
                       u'    </td>\n'