Index: /trunk/src/VBox/Frontends/VirtualBox/src/manager/UIToolPaneGlobal.cpp
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox/src/manager/UIToolPaneGlobal.cpp	(revision 83481)
+++ /trunk/src/VBox/Frontends/VirtualBox/src/manager/UIToolPaneGlobal.cpp	(revision 83482)
@@ -45,4 +45,5 @@
     , m_pPaneCloud(0)
     , m_pPaneResourceMonitor(0)
+    , m_fActive(false)
 {
     /* Prepare: */
@@ -54,4 +55,16 @@
     /* Cleanup: */
     cleanup();
+}
+
+void UIToolPaneGlobal::setActive(bool fActive)
+{
+    /* Save activity: */
+    if (m_fActive != fActive)
+    {
+        m_fActive = fActive;
+
+        /* Handle token change: */
+        handleTokenChange();
+    }
 }
 
@@ -194,4 +207,7 @@
         }
     }
+
+    /* Handle token change: */
+    handleTokenChange();
 }
 
@@ -221,4 +237,7 @@
         delete pWidget;
     }
+
+    /* Handle token change: */
+    handleTokenChange();
 }
 
@@ -242,2 +261,7 @@
     }
 }
+
+void UIToolPaneGlobal::handleTokenChange()
+{
+    // printf("UIToolPaneGlobal::handleTokenChange: Active = %d, current tool = %d\n", m_fActive, currentTool());
+}
Index: /trunk/src/VBox/Frontends/VirtualBox/src/manager/UIToolPaneGlobal.h
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox/src/manager/UIToolPaneGlobal.h	(revision 83481)
+++ /trunk/src/VBox/Frontends/VirtualBox/src/manager/UIToolPaneGlobal.h	(revision 83482)
@@ -59,4 +59,9 @@
     virtual ~UIToolPaneGlobal() /* override */;
 
+    /** Defines whether this pane is @a fActive. */
+    void setActive(bool fActive);
+    /** Returns whether this pane is active. */
+    bool active() const { return m_fActive; }
+
     /** Returns type of tool currently opened. */
     UIToolType currentTool() const;
@@ -77,4 +82,7 @@
     void cleanup();
 
+    /** Handles token change. */
+    void handleTokenChange();
+
     /** Holds the action pool reference. */
     UIActionPool *m_pActionPool;
@@ -92,4 +100,7 @@
     /** Holds the VM Resource Monitor instance. */
     UIResourceMonitorWidget     *m_pPaneResourceMonitor;
+
+    /** Holds whether this pane is active. */
+    bool  m_fActive;
 };
 
Index: /trunk/src/VBox/Frontends/VirtualBox/src/manager/UIToolPaneMachine.cpp
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox/src/manager/UIToolPaneMachine.cpp	(revision 83481)
+++ /trunk/src/VBox/Frontends/VirtualBox/src/manager/UIToolPaneMachine.cpp	(revision 83482)
@@ -46,4 +46,5 @@
     , m_pPaneSnapshots(0)
     , m_pPaneLogViewer(0)
+    , m_fActive(false)
 {
     /* Prepare: */
@@ -55,4 +56,16 @@
     /* Cleanup: */
     cleanup();
+}
+
+void UIToolPaneMachine::setActive(bool fActive)
+{
+    /* Save activity: */
+    if (m_fActive != fActive)
+    {
+        m_fActive = fActive;
+
+        /* Handle token change: */
+        handleTokenChange();
+    }
 }
 
@@ -175,4 +188,7 @@
         }
     }
+
+    /* Handle token change: */
+    handleTokenChange();
 }
 
@@ -202,4 +218,7 @@
         delete pWidget;
     }
+
+    /* Handle token change: */
+    handleTokenChange();
 }
 
@@ -278,2 +297,7 @@
     }
 }
+
+void UIToolPaneMachine::handleTokenChange()
+{
+    // printf("UIToolPaneMachine::handleTokenChange: Active = %d, current tool = %d\n", m_fActive, currentTool());
+}
Index: /trunk/src/VBox/Frontends/VirtualBox/src/manager/UIToolPaneMachine.h
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox/src/manager/UIToolPaneMachine.h	(revision 83481)
+++ /trunk/src/VBox/Frontends/VirtualBox/src/manager/UIToolPaneMachine.h	(revision 83482)
@@ -68,4 +68,9 @@
     virtual ~UIToolPaneMachine() /* override */;
 
+    /** Defines whether this pane is @a fActive. */
+    void setActive(bool fActive);
+    /** Returns whether this pane is active. */
+    bool active() const { return m_fActive; }
+
     /** Returns type of tool currently opened. */
     UIToolType currentTool() const;
@@ -101,4 +106,7 @@
     void cleanup();
 
+    /** Handles token change. */
+    void handleTokenChange();
+
     /** Holds the action pool reference. */
     UIActionPool *m_pActionPool;
@@ -118,4 +126,7 @@
     UIVMLogViewerWidget *m_pPaneLogViewer;
 
+    /** Holds whether this pane is active. */
+    bool  m_fActive;
+
     /** Holds the cache of passed items. */
     QList<UIVirtualMachineItem*>  m_items;
Index: /trunk/src/VBox/Frontends/VirtualBox/src/manager/UIVirtualBoxManagerWidget.cpp
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox/src/manager/UIVirtualBoxManagerWidget.cpp	(revision 83481)
+++ /trunk/src/VBox/Frontends/VirtualBox/src/manager/UIVirtualBoxManagerWidget.cpp	(revision 83482)
@@ -270,4 +270,6 @@
             m_pPaneTools->setToolsClass(UIToolClass_Machine);
             m_pStackedWidget->setCurrentWidget(m_pPaneToolsMachine);
+            m_pPaneToolsGlobal->setActive(false);
+            m_pPaneToolsMachine->setActive(true);
             break;
         }
@@ -276,4 +278,6 @@
             m_pPaneTools->setToolsClass(UIToolClass_Global);
             m_pStackedWidget->setCurrentWidget(m_pPaneToolsGlobal);
+            m_pPaneToolsMachine->setActive(false);
+            m_pPaneToolsGlobal->setActive(true);
             break;
         }
@@ -461,4 +465,6 @@
                         if (m_pPaneToolsGlobal)
                         {
+                            if (m_pPaneChooser->isGlobalItemSelected())
+                                m_pPaneToolsGlobal->setActive(true);
                             connect(m_pPaneToolsGlobal, &UIToolPaneGlobal::sigCloudProfileManagerChange,
                                     this, &UIVirtualBoxManagerWidget::sigCloudProfileManagerChange);
@@ -472,4 +478,6 @@
                         if (m_pPaneToolsMachine)
                         {
+                            if (!m_pPaneChooser->isGlobalItemSelected())
+                                m_pPaneToolsMachine->setActive(true);
                             connect(m_pPaneToolsMachine, &UIToolPaneMachine::sigCurrentSnapshotItemChange,
                                     this, &UIVirtualBoxManagerWidget::sigCurrentSnapshotItemChange);